#include <Imagine/Graphics.h>
#include <cstdlib>
#include "grille.h"
using namespace Imagine;
using namespace std;

const int w=100;
const int h=60;

// Utiliser nIters=0 pour un nombre "illimite"
void animation(Grille& g, int nIters) {
    for(int i=1; i!=nIters; i++) {
        g.update();
        g.dessine();
        milliSleep(10);
    }
    click();
}

void bonneAnnee(Grille& g) {
    drawString(z*5,z*h/2, "Bonne annee !", BLACK, 40);
    click();
    Color* col;
    int w2,h2;
    captureWindow(col, w2, h2);
    for(int y=0; y<h; y++)
        for(int x=0; x<w; x++)
            g.set(x,y,false);
    for(int y=0; y<h2; y++)
        for(int x=0; x<w2; x++)
            if(col[w2*y+x]==BLACK)
                g.set(x/z,y/z,true);
    delete [] col;
    clearWindow();
    g.dessine();
}

int main(){
    Grille g(w,h);
    g.ligne(w/2,h/2);
    g.grenouille(w/5,h/5);
    g.planeur(3*w/5,2*h/3);

    openWindow(z*w, z*h);
    g.dessine();

    int x, y;
    while(getMouse(x,y) != 3) {
        x = int(x/z);
        y = int(y/z);
        g.toggle(x, y);
        g.dessine();
    }
    animation(g, 26);

    clearWindow();
    bonneAnnee(g);
    click();
    animation(g,100);

    endGraphics();
    return 0;
}
